// -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil;c-basic-offset: 2 -*-

var NVBrowserProgressListener = {
    stateIsRequest:false,
    listened:false,
	
    QueryInterface : function(aIID) {
        if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
            aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
            aIID.equals(Components.interfaces.nsISupports))
                return this;
        throw Components.results.NS_NOINTERFACE;
    },
	
    // This method is called to indicate state changes.
    onStateChange: function(webProgress, request, stateFlags, status) {
      //dump("state change \n");  
    },
    
    onProgressChange : function(a,b,c,d,e,f) {
      //dump("progress change \n");  
    },
    onStatusChange : function(a,b,c,d) { 
      //dump("status change \n");  
    },
    onSecurityChange : function(a,b,c){},
    onLinkIconAvailable : function(a){},
	
    onLocationChange : function(aProgress, aRequest, aLocation) {
//      dump('onlocation change ' + aLocation.spec.toString() + '\n');
//      dump('onlocation aRequest ' + aRequest + '\n');
      if( aProgress.isLoadingDocument==false )
        NVonTabChange(aLocation);
//        NVpageData(window._content.document);
    }
};

/** 
 * To access easily to different Mozilla Services 
 */ 
var NVservice = { 
    RDF    : Components.classes['@mozilla.org/rdf/rdf-service;1'] 
               .getService(Components.interfaces.nsIRDFService), 
    RDFC   : Components.classes['@mozilla.org/rdf/container;1'] 
               .getService(Components.interfaces.nsIRDFContainer), 
    RDFCU  : Components.classes['@mozilla.org/rdf/container-utils;1'] 
               .getService(Components.interfaces.nsIRDFContainerUtils), 
    DIR    : Components.classes['@mozilla.org/file/directory_service;1'] 
               .getService(Components.interfaces.nsIProperties),
    FILE   : Components.classes["@mozilla.org/file/local;1"]
               .getService(Components.interfaces.nsILocalFile),
    IO     : Components.classes['@mozilla.org/network/io-service;1'] 
               .getService(Components.interfaces.nsIIOService), 
    UC     : Components.classes['@mozilla.org/intl/scriptableunicodeconverter'] 
               .getService(Components.interfaces.nsIScriptableUnicodeConverter), 
    WM     : Components.classes['@mozilla.org/appshell/window-mediator;1'] 
               .getService(Components.interfaces.nsIWindowMediator), 
    WW     : Components.classes['@mozilla.org/embedcomp/window-watcher;1']
               .getService(Components.interfaces.nsIWindowWatcher),
    AS     : Components.classes["@mozilla.org/appshell/appShellService;1"]
               .getService(Components.interfaces.nsIAppShellService),
    PB     : Components.classes['@mozilla.org/preferences;1'] 
               .getService(Components.interfaces.nsIPrefBranch), 
    PS     : Components.classes['@mozilla.org/preferences-service;1'] 
               .getService(Components.interfaces.nsIPrefService ),
    HISTORY: Components.classes["@mozilla.org/rdf/datasource;1?name=history"]
               .getService(Components.interfaces.nsIRDFDataSource)
}; 
 
 
 
var NVcommon = { 

  hiddenWnd : null,
  dumpLevel : 0, 
  dumpTrash : "",
  dumpCounter: 0,
    
  	/** 
     * Get user's profile extention directory. 
     * If it doesn't exist we create it 
     * else returns it 
     */ 
    getProfileDir : function() 
    { 
        var myDataDir = NVservice.DIR.get("ProfD", Components.interfaces.nsIFile); 
        myDataDir.append("navtracer"); 
        if ( !myDataDir.exists() ) 
        { 
            myDataDir.create(myDataDir.DIRECTORY_TYPE, 0700); 
        } 
        return myDataDir; 
    }, 
 
   /**
    * Grab data contained in the clipboard
    */
    getClipboardData : function ( ) {
      var text = new String("");

      /* clipboard interface */    
      var clip = Components.classes["@mozilla.org/widget/clipboard;1"]
                      .createInstance(Components.interfaces.nsIClipboard);
      if (!clip) return false;

      /* used to transfer the data */
      var trans = Components.classes["@mozilla.org/widget/transferable;1"]
                      .createInstance(Components.interfaces.nsITransferable);
      if (!trans) return false;
      trans.addDataFlavor("text/unicode");

      clip.getData(trans,clip.kGlobalClipboard);

      var str = new Object();
      var strLength = new Object();

      trans.getTransferData("text/unicode",str,strLength);
      
      if (str)
          str=str.value.QueryInterface(Components.interfaces.nsISupportsString);
      if (str)
          text = str.data.substring(0,strLength.value / 2);
          
      return text;
    },

 
    getCurrentUrl : function () 
    {
      var url;
      try {
        url = _content.location.href;
        //dump("getCurrentUrl : " + url + "\n");
      }
//      try {
//        if (document.commandDispatcher.focusedWindow && 
//            document.commandDispatcher.focusedWindow.document) {
//          //url = document.getElementById("content").webNavigation.currentURI.spec
//          url = new String(document.commandDispatcher.focusedWindow.document.URL);
//        }
//      
//        if (url == 'undefined' && _content)
//          url = _content.location.href;
//        
//        if (!url) {
//          url = document.getElementById("urlbar").value;
//        }
//      }
      catch (e) {
        dump("FAILED getCurrentUrl : " + e + "\n")
      }
      return url;
    },
    
    loadURL : function(aURL, tabbed) 
    { 
        var topWindow = NVservice.WM.getMostRecentWindow("navigator:browser"); 
        var myBrowser = topWindow.document.getElementById("content"); 
        if ( tabbed ) { 
            myBrowser.selectedTab = myBrowser.addTab(aURL); 
        } else { 
            myBrowser.loadURI(aURL); 
        } 
    }, 
 
        
    getTimeStamp : function(advance) 
    { 
        var dd = new Date; 
        if ( advance ) dd.setTime(dd.getTime() + 1000 * advance); 
        var y = dd.getFullYear(); 
        var m = dd.getMonth() + 1; if ( m < 10 ) m = "0" + m; 
        var d = dd.getDate();      if ( d < 10 ) d = "0" + d; 
        var h = dd.getHours();     if ( h < 10 ) h = "0" + h; 
        var i = dd.getMinutes();   if ( i < 10 ) i = "0" + i; 
        var s = dd.getSeconds();   if ( s < 10 ) s = "0" + s; 
        return y.toString() + m.toString() + d.toString() + h.toString() + i.toString() + s.toString(); 
    }, 
 
 
    getFocusedWindow : function() 
    { 
        var myWindow = document.commandDispatcher.focusedWindow; 
        if ( !myWindow || myWindow == window ) myWindow = window._content; 
        return myWindow; 
    },

    getReferrer : function ()
    {
       var currentURL = NVservice.RDF.GetResource(_content.location.href);
       var referrerResource = NVservice.RDF.GetResource("http://home.netscape.com/NC-rdf#Referrer");
       var urlResource;

       try {
         urlResource = NVservice.HISTORY.GetTarget(currentURL, referrerResource, true);
         dump ("Referrer :" + urlResource.QueryInterface(Components.interfaces.nsIRDFResource).ValueUTF8 + "\n");
       } catch(e) {
         return null;
       }
       
       return urlResource.QueryInterface(Components.interfaces.nsIRDFResource).Value
    },
    
    dumpDebug : function (msg, level) 
    {
      if (level) 
        if (level > this.dumpLevel) { dump(this.dumpCounter + " " + msg); this.dumpCounter++;}
        //else dumpTrash += msg;
      else { dump(dumpCounter++ + " " + msg); }
    }

};
